<template>
    <div
        v-if="popup && shop"
        class="growth_preview"
    >
        <div class="popup-preview-toggle-container">
            <span><strong>Pop Up Preview:</strong></span>
            <span
                class="space-margin"
                @click="[deviceType=0, reload(), previewType.type=0]"
            >
                <svg
                    v-if="deviceType===0"
                    xmlns="http://www.w3.org/2000/svg"
                    width="28"
                    height="26"
                    viewBox="0 0 28 26"
                >
                    <path
                        id="icons8-imac"
                        d="M5.333,4A2.348,2.348,0,0,0,3,6.364V22.909A2.128,2.128,0,0,0,5.333,25h9.042l-.583,2.636H12.333a1.182,1.182,0,0,0,0,2.364h9.333a1.182,1.182,0,0,0,0-2.364H20.208L19.625,25h9.042A2.128,2.128,0,0,0,31,22.909V6.364A2.348,2.348,0,0,0,28.667,4Zm0,3H28.667V20H5.333ZM17,21.727a1.182,1.182,0,1,1-1.167,1.182A1.175,1.175,0,0,1,17,21.727Z"
                        transform="translate(-3 -4)"
                        fill="#4786ff"
                    />
                </svg>
                <svg
                    v-else
                    xmlns="http://www.w3.org/2000/svg"
                    width="28"
                    height="26"
                    viewBox="0 0 28 26"
                >
                    <path
                        id="icons8-imac"
                        d="M5.333,4A2.348,2.348,0,0,0,3,6.364V22.909A2.128,2.128,0,0,0,5.333,25h9.042l-.583,2.636H12.333a1.182,1.182,0,0,0,0,2.364h9.333a1.182,1.182,0,0,0,0-2.364H20.208L19.625,25h9.042A2.128,2.128,0,0,0,31,22.909V6.364A2.348,2.348,0,0,0,28.667,4Zm0,3H28.667V20H5.333ZM17,21.727a1.182,1.182,0,1,1-1.167,1.182A1.175,1.175,0,0,1,17,21.727Z"
                        transform="translate(-3 -4)"
                        fill="#d7d9db"
                    />
                </svg>
            </span>
            <span
                class="space-margin"
                @click="[deviceType=1, reload(), previewType.type=1]"
            >
                <svg
                    v-if="deviceType===1"
                    xmlns="http://www.w3.org/2000/svg"
                    width="16"
                    height="26"
                    viewBox="0 0 16 26"
                >
                    <path
                        id="icons8-touchscreen"
                        d="M21,2H9A2,2,0,0,0,7,4V26a2,2,0,0,0,2,2H21a2,2,0,0,0,2-2V4A2,2,0,0,0,21,2Zm0,23H17a1,1,0,0,1-1,1H14a1,1,0,0,1-1-1H9V5H21Z"
                        transform="translate(-7 -2)"
                        fill="#4786ff"
                    />
                </svg>
                <svg
                    v-else
                    xmlns="http://www.w3.org/2000/svg"
                    width="16"
                    height="26"
                    viewBox="0 0 16 26"
                >
                    <path
                        id="icons8-touchscreen"
                        d="M21,2H9A2,2,0,0,0,7,4V26a2,2,0,0,0,2,2H21a2,2,0,0,0,2-2V4A2,2,0,0,0,21,2Zm0,23H17a1,1,0,0,1-1,1H14a1,1,0,0,1-1-1H9V5H21Z"
                        transform="translate(-7 -2)"
                        fill="#d7d9db"
                    />
                </svg>
            </span>
        </div>
        <div
            v-if="popup.colors"
            :class="{'mobile-border-preview': deviceType === 1}"
            class="preview_box__wrapper"
        >
            <div class="preview-box form-group preview form-inline edit__set_block white-space">
                <div class="desktop-circle-camera" />
                <div class="preview-store-background">
                    <div
                        v-if="popup.bar_position != 2"
                        :style="{backgroundColor: popup.colors.bar_color}"
                        :class="position"
                        class="bar-block"
                    >
                        <div
                            :style="{color: popup.colors.bar_text}"
                            v-html="replaceShortcodes(popup.bar_text)"
                        />
                        <div
                            v-if="popup.bar_allow_closing"
                            class="right-icon"
                        >
                            <svg
                                xmlns="http://www.w3.org/2000/svg"
                                width="9"
                                height="9"
                                viewBox="0 0 12 12"
                            >
                                <path
                                    id="icons8-multiply"
                                    d="M5.394,4.293l-1.1,1.1,4.9,4.9-4.9,4.9,1.1,1.1,4.9-4.9,4.9,4.9,1.1-1.1-4.9-4.9,4.9-4.9-1.1-1.1-4.9,4.9Z"
                                    transform="translate(-4.293 -4.293)"
                                    :fill="popup.colors.bar_btn_color"
                                />
                            </svg>
                        </div>
                    </div>
                    <div
                        v-if="showNewModal"
                        class="pop-up-main-container"
                    >
                        <New
                            :popup="popup"
                            :show-thank="showThank"
                        />
                    </div>
                    <template v-else>
                        <div
                            class="pop-up-main-container"
                            :style="popup.popup_background_type==1?{backgroundColor: popup.colors.settings_background}:
                                {'background-image': `url(${popup.background_image})`}"
                        >
                            <span class="close-button">×</span>
                            <StyleFirstTimer
                                v-if="popup.timer_style == 1"
                                :popup="popup"
                            />
                            <StyleSecondTimer
                                v-if="popup.timer_style == 2"
                                :popup="popup"
                            />
                            <style-first
                                v-if="popup.popup_style==1 && deviceType === 0 && renderComponent"
                                class="desktop-style-first"
                                :show-thank="showThank"
                                :popup="popup"
                                :active-offers="activeOffers"
                                :device-type="deviceType"
                            />
                            <StyleFirstMobile
                                v-if="popup.popup_style == 1 && deviceType === 1 && renderComponent"
                                :show-thank="showThank"
                                :active-offers="activeOffers"
                                :popup="popup"
                                :device-type="deviceType"
                            />
                            <style-second
                                v-if="popup.popup_style==2 && renderComponent"
                                class="second-style"
                                :show-thank="showThank"
                                :popup="popup"
                                :device-type="deviceType"
                            />
                        </div>
                    </template>
                </div>
                <div
                    class="stand-container"
                    :class="{'hide-stand': deviceType === 1}"
                >
                    <img
                        src="/images/Monitor-stand.svg"
                        alt=""
                    >
                </div>


                <!--                <StyleFirstTimer v-if="popup.timer_style == 1" :popup="popup"/>-->
                <!--                <StyleSecondTimer v-if="popup.timer_style == 2" :popup="popup"/>-->
                <!--                <style-first :showThank="showThank" v-if="popup.popup_style==1 && renderComponent" :popup="popup" :device-type="deviceType"/>-->
                <!--                <style-second :showThank="showThank" v-if="popup.popup_style==2 && renderComponent" :popup="popup" :device-type="deviceType"/>-->
                <!--                <StyleThird v-if="popup.popup_style==3 && renderComponent" :popup="popup" :device-type="deviceType"/>-->
                <!--              <StyleFourth v-if="popup.popup_style==4 && renderComponent" :popup="popup" :device-type="deviceType"/>-->
                <!--                <br>-->
                <!--              <div :style="{backgroundColor: popup.colors.bar_color}" v-if="popup.bar_position != 2" :class="position" class="bar-block">-->
                <!--                <div :style="{color: popup.colors.bar_text}" v-html="replaceShortcodes(popup.bar_text)"></div>-->
                <!--                <div v-if="popup.bar_allow_closing" class="right-icon">-->
                <!--                  <svg xmlns="http://www.w3.org/2000/svg" width="12" height="12" viewBox="0 0 12 12">-->
                <!--                    <path id="icons8-multiply"-->
                <!--                          d="M5.394,4.293l-1.1,1.1,4.9,4.9-4.9,4.9,1.1,1.1,4.9-4.9,4.9,4.9,1.1-1.1-4.9-4.9,4.9-4.9-1.1-1.1-4.9,4.9Z"-->
                <!--                          transform="translate(-4.293 -4.293)" :fill="popup.colors.bar_btn_color"/>-->
                <!--                  </svg>-->
                <!--                </div>-->
                <!--              </div>-->
            </div>
        </div>
    </div>
</template>

<script>
import StyleFirst from "./previewHelper/StyleFirst";
import StyleSecond from "./previewHelper/StyleSecond";
import StyleFirstTimer from './previewHelper/timer/StyleFirst'
import StyleSecondTimer from "./previewHelper/timer/StyleSecond";
import StyleFirstMobile from "./previewHelper/StyleFirstMobile";
import shop from '@/mixins/shop.service'
import New from '@/components/growth-tools/New.vue'
export default {
    components: {StyleFirstMobile, StyleSecondTimer, StyleFirst, StyleSecond, StyleFirstTimer, New},
    mixins:[
      shop
    ],
    props: {
        popup: Object,
        showThank: Array,
        previewType: Object,
        showNewModal: Boolean,
    },
    data() {
        return {
            renderComponent: true,
            activeOffers: 0,
            deviceType: 0,
            hourOne: 0,
            hourTwo: 0,
            minuteOne: 0,
            minuteTwo: 0,
            secondOne: 0,
            secondTwo: 0,
            shop: null,
            code: Math.random().toString(36).slice(2, 8).toUpperCase(),
        }
    },
    computed: {
        position() {
            return {
                'top': this.popup.bar_position === '0',
                'bot': this.popup.bar_position === '1'
            }
        },
    },
    watch: {
        popup: {
            deep: true,
            handler() {
              this.activeOffers = 0
              this.popup.growth_offers.map(offer => {
                if (offer.status) {
                  this.activeOffers ++
                }
              });
                this.setTimer();
            }
        },
    },
    async mounted() {
        this.shop = await this.getShop();
        this.popup.growth_offers.map(offer => {
            if (offer.status) {
                this.activeOffers ++
            }
        });
        this.setTimer();
    },
    methods: {
        setTimer() {
            this.hourTwo = this.popup.hours % 10;
            this.hourOne = Math.trunc(this.popup.hours / 10);
            this.minuteTwo = this.popup.minutes % 10;
            this.minuteOne = Math.trunc(this.popup.minutes / 10);
            this.secondTwo = this.popup.seconds % 10;
            this.secondOne = Math.trunc(this.popup.seconds / 10);
        },
        replaceShortcodes(text) {
            if (text) {
                text = text.replace(/{siteName}/g, this.shop.company_name);
                text = text.replace(/{domain}/g, '<a href="#">' + this.shop.shop_url + '</a>');
                text = text.replace(/{storeEmail}/g, this.shop.email);
                text = text.replace(/{discountValue}/g, this.popup.growth_offers[0].automatic_discount_enabled == 1 ? this.popup.growth_offers[0].automatic_discount_value : '');
                text = text.replace(/{discountCode}/g, this.popup.growth_offers[0].automatic_discount_enabled == 1 ? this.code : this.popup.growth_offers[0].code);
                text = text.replace(/{timeLeft}/g,
                    this.hourOne + '' + this.hourTwo
                    + ' : ' +
                    this.minuteOne + '' + this.minuteTwo
                    + ' : ' +
                    this.secondOne + '' + this.secondTwo
                );
            }
            return text;
        },
        reload() {
            this.renderComponent = false;
            this.$nextTick(() => {
                this.renderComponent = true;
            });
        },
    }
}
</script>

<style lang="scss">

.close-button {
  font-size: 22px;
  font-weight: 500;
  position: absolute;
  right: 20px;
  top: 10px;
}
@media(max-width: 1600px) {
    .preview_box {
        &__wrapper {
            width: 100%;
            overflow-x: auto;
             .preview-box {
                min-width: 900px
            }
        }
    }
}
.mobile-border-preview {
    .preview-box {
        min-width: auto !important;
    }
}


.stand-container {
    display: flex;
    justify-content: center;

    img {
        margin-top: -10px;
    }
}

.hide-stand {
    display: none;
}

.pop-up-main-container {
    position: absolute;
    top: 40px;
    padding: 0px 15px;
    display: flex;
    flex-direction: column;
    justify-content: center;
    bottom: 40px;
    right: 45px;
    left: 45px;
    background-size: cover;
    background-repeat: no-repeat;
    background-position: center;
}


.desktop-circle-camera {
    width: 10px;
    height: 10px;
    top: 11px;
    border-radius: 50%;
    position: absolute;
    background: rgba(0, 0, 0, 0.1);
    right: calc(50% - 5px);
}

.preview-store-background {
    position: absolute;
    background-color: rgba(0, 0, 0, .2);
    top: 5%;
    right: 3.5%;
    bottom: 5%;
    left: 3.5%;
  border-radius: 5px;
}


.growth-tab-icon {
    fill: #d7d9db !important;
}

.growth-tab-icon {
    margin-right: 10px;
}

.nav-tabs > li > a:hover {
    .growth-tab-icon {
        fill: #4786ff !important;
    }
}

.nav-tabs > li.active > a {
    .growth-tab-icon {
        fill: #4786ff !important;
    }
}

.growth-tab-container {
    display: flex;
    align-items: center;
}

.preview {
    text-align: center;
}

.popup-preview-toggle-container {
    display: flex;
    align-items: center;
}

.pretty {
    margin-right: 0px !important;
}

.phone-input-container {
    margin-left: 5px;
}

.preview-thank-code {
  font-size: 16px;
  font-weight: bold;
}
.timer-style-2 {
  height: 80px !important;
  font-weight: 500;
}
.timer-style-1 {
  height: 80px !important;
}

.growth-action-icons {
  width: 15px;
  height: 15px;
}

.mobile-border-preview {
    max-width: 350px;
    padding: 0 !important;
    margin-right: auto;
    margin-left: auto;
  .close-button {
    top: 16px !important;
  }

  .growth-cart-container {
    height: auto !important;
  }
  .timer-style-2 {
  height: 52px !important;
}
  .timer-style-1 {
    height: 52px !important;
    margin-top: 15px !important;
  }
    background: none !important;


  .second-style {
    .growth-cart-container {
      width: 80% !important;
    }
  }
    .email-input {
        width: 80% !important;
    }

    .timer-number-background span {
        font-size: 16px !important;
    }

    .timer-number-background {
        min-width: 160px !important;
        padding: 2px 15px !important;
    }

    .gift-size-1 {
        height: 25px;
    }

    .gift-size-2 {
        height: 35px;
    }

    .gift-size-3 {
        height: 45px;
    }

    .timer-style-1 {
        flex-direction: column;
    }

    .growth-cart-container {
        box-shadow: none;
    }

    .pop-up-main-container {
        right: 15px;
        left: 15px;
        padding-top: 10px;
    }

    .preview-box .row {
        margin-left: -15px !important;
        margin-right: -15px !important;
    }

    .growth-cart-container {
        width: 100% !important;
    }

    .timer-number-style-1 {
        padding: 5px 5px !important;
        font-size: 16px !important;
    }

    .timer-style-2 {
        margin-top: 15px !important;
    }

    .timer-text {
        margin-right: 0;
    }

    .growth-cart-container {
        width: 94%;
    }

    .nav-btn-prev {
        width: 30px !important;
        height: 30px !important;
        left: 0 !important;
    }

    .nav-btn-next {
        width: 30px !important;
        height: 30px !important;
        right: 0 !important;
    }

    .bar-block {
        font-size: 10px;
    }

    .desktop-circle-camera {
        width: 60px;
        height: 10px;
        top: 11px;
        border-radius: 5px;
        position: absolute;
        background: rgba(0, 0, 0, 0.1);
        right: calc(50% - 30px);
    }

    .preview-box {
        position: relative;
        width: 100%;
        height: 600px;
        padding-top: 60px !important;
        padding-bottom: 60px !important;
    }

    .preview-store-background {
        position: absolute;
        background-color: rgba(0, 0, 0, 0.2);
        top: 6%;
        right: 6.5%;
        bottom: 5%;
        left: 6.5%;
    }

    .gift-container {
        margin-bottom: 20px;
    }

    .items-center {
        flex-direction: column;
    }

}

.messenger-container {
    display: flex;
    font-size: 8px;
    align-items: center;

    img {
        margin-right: 2px;
    }
}


.get-discount-btn-full {
    color: #98A0A6;
    padding: 4px;
    background: #DEE1E6;
    border-radius: 5px;
    text-align: center;
    font-size: 11px;
    margin-top: 10px;
    width: 100%;
    min-width: 95px;
}

.growth-input-icon-container {
    min-width: 25px;
    min-height: 25px;
    width: 25px;
    height: 25px;
    display: flex;
    margin-right: 10px;
    border-radius: 5px;
    justify-content: center;
    align-items: center;
}

.messenger-container2 {
    display: flex;
    font-size: 8px;
    align-items: center;
    color: #98A0A6;
    font-weight: 300;
    margin-top: 5px;

    img {
        margin-right: 2px;
    }

    a {
        font-weight: 500;
        margin-left: 2px;
        color: #98A0A6;
    }
}

.phone-number {
    font-size: 8px;
    text-align: left;
    margin-bottom: -5px;
}

.sms-phone-container {
    display: flex;
    justify-content: flex-start;
    align-items: center;
    border-radius: 5px;
}

.facebook-check {
    font-size: 8px;
    width: 42px;
    display: flex;
}

.input-img-container {
    position: relative;
}

.growth-cart-container {
    background: white;
    display: flex;
    flex-direction: column;
    border-radius: 10px;
    height: 100%;
    margin-top: 8px;
    justify-content: center;
    align-items: center;
    box-shadow: 0 0 4px 0 rgba(0, 0, 0, 0.2), 0 4px 3px rgba(0, 0, 0, 0.08);
    @media screen and (max-width: 1500px) {
        width: 65% !important;
    }
    @media screen and (max-width: 660px) {
        width: 90% !important;
    }

}

@media screen and (max-width: 660px) {
    .nav-btn-prev {
        left: 15% !important;
    }
    .nav-btn-next {
        right: 15% !important;
    }
}


.gift-container {
    align-items: end;
    @media screen and (max-width: 1200px) {
        height: auto;
        margin-top: 20px;
    }
}

.action-gift-container {
    justify-content: flex-end;
    display: flex;
    flex-direction: column;
    padding: 20px 20px;
    border-radius: 5px;
    box-shadow: 0px 0px 4px rgba(0, 0, 0, 0.12);
    @media screen and (max-width: 1200px) {
        justify-content: center;
        height: auto;
    }
}

.usa-icon {
    position: absolute;
    top: 9px;
    left: 2px;
}

.arrow-down {
    position: absolute;
    top: 12px;
    left: 12px;
}

.gift-input-container {
    position: relative;
    padding-right: 17px;
    min-width: 100px;
    margin-top: 7px;
    @media screen and (max-width: 1200px) {
        min-width: 120px;
    }
}

.email-input, .push-text {
    width: calc(100% - 35px) !important;
    height: 25px;
    border: 1px solid #DAE7FF;
    border-radius: 5px;
    font-size: 12px;
    @media screen and (max-width: 1200px) {
        font-size: 9px;
    }
}

.sms-phone-input {
    width: 100%;
    height: 14px;
    border: 1px solid #DAE7FF;
    border-radius: 5px;
    font-size: 7px;
    padding-left: 17px;
}

.get-discount-btn {
    color: #98A0A6;
    position: absolute;
    right: 0;
    bottom: 0;
    padding: 3px;
    background: #DEE1E6;
    border-radius: 5px;
    text-align: center;
    font-size: 7px;
}


.timer-number-style-1 {
    padding: 5px 7px;
    font-size: 20px;
    background-color: #F5F6FA;
    border-radius: 5px;
    margin-right: 5px;
}

.space-margin {
    margin-left: 15px;
    cursor: pointer;
}

.timer-text {
    margin-right: 10px;
    @media screen and (max-width: 500px) {
        margin-bottom: 10px;
        margin-right: 0px;
    }
}

.timer-style-1 {
    display: flex;
    justify-content: center;
    color: #707070;
    align-items: center;
    height: 80px;
    margin-top: 10px;
    font-weight: 500;
    @media screen and (max-width: 500px) {
        flex-direction: column;
        font-size: 10px;
    }
}

.border-preview {
    position: relative;
    padding: 70px;
    @media screen and (max-width: 500px) {
        padding: 40px;
    }
}

.bar-block {
    background-color: #E5E6E8;
    position: absolute;
    display: flex;
    justify-content: space-between;
    align-items: center;
    bottom: 0;
    font-size: 10px;
    width: 100%;
    left: 0;
    height: 35px;
    padding-left: 15px;

    @media screen and (max-width: 600px) {
        font-size: 10px;
    }
    @media screen and (max-width: 400px) {
        font-size: 8px;
    }
}

.edit__set_block {
    position: relative;
}

.top {
    top: 0;
  border-top-right-radius: 5px;
  border-top-left-radius: 5px;

}

.bot {
    bottom: 0;
  border-bottom-right-radius: 5px;
  border-bottom-left-radius: 5px;
}

.right-icon {
    margin-right: 15px;
    float: right;
}

.gift-size-1 {
    height: 45px;
}

.gift-size-2 {
    height: 55px;
}

.gift-size-3 {
    height: 75px;
}

.gift-size-4 {
    height: 95px;
    margin: 10px;
}

.gifts-parent {
    display: flex;
    justify-content: center;
}

.push-text {
    display: flex;
    align-items: center;
    justify-content: center;
    @media screen and (max-width: 1200px) {
        font-size: 9px !important;
        padding-left: 0 !important;
    }
}

.preview-box {
    height: 600px;
    min-width: 770px;
    max-width: 1000px;
    // box-shadow: 0px 0px 24px 6px rgba(34, 60, 80, 0.2);
    padding: 0 !important;
    background-color: white !important;
    display: flex;
    border-radius: 40px;
    flex-direction: column;
    justify-content: center;

    .row {
        margin-left: 0 !important;
        margin-right: 0 !important;
        margin-top: 20px;
    }

    @media screen and (max-width: 1200px) {
        padding-top: 60px !important;
        padding-bottom: 60px !important;
        width: auto;
        position: relative;
    }
}
</style>

<style lang="scss">
.growth_preview {
    .col-1, .col-2, .col-3, .col-4, .col-5, .col-6, .col-7, .col-8, .col-9, .col-10, .col-11, .col-12, .col, .col-auto, .col-sm-1, .col-sm-2, .col-sm-3, .col-sm-4, .col-sm-5, .col-sm-6, .col-sm-7, .col-sm-8, .col-sm-9, .col-sm-10, .col-sm-11, .col-sm-12, .col-sm, .col-sm-auto, .col-md-1, .col-md-2, .col-md-3, .col-md-4, .col-md-5, .col-md-6, .col-md-7, .col-md-8, .col-md-9, .col-md-10, .col-md-11, .col-md-12, .col-md, .col-md-auto, .col-lg-1, .col-lg-2, .col-lg-3, .col-lg-4, .col-lg-5, .col-lg-6, .col-lg-7, .col-lg-8, .col-lg-9, .col-lg-10, .col-lg-11, .col-lg-12, .col-lg, .col-lg-auto, .col-xl-1, .col-xl-2, .col-xl-3, .col-xl-4, .col-xl-5, .col-xl-6, .col-xl-7, .col-xl-8, .col-xl-9, .col-xl-10, .col-xl-11, .col-xl-12, .col-xl, .col-xl-auto {
        width: auto;
    }
    .gift-size-container, .gift-container, .line1, .line2{
        min-width: 33%;
    }
}
</style>
